<%--<script src="js/library/jquery-ui-1.8.16.custom/js/jquery-ui-1.8.16.custom.min.js"></script>--%>
<script type="text/javascript">


var InterfaceTapas;
InterfaceTapas = Class.create( {
    initialize: function( jsonFileFormats, jsonYesNos, jsonObservatories, jsonSpectralUnits, jsonInstrumentalFunctions, jsonClimatoReferences )
    {
        /** *********** CONTAINERS *********** **/
        this.containerForm = $( "#formulaire" );
        //this.containerErrors = $( "#errForm" );
        //this.divE= $( "#divErreurs");
        this.containerCenter = $( "#containerCenter" );
        this.containerTabs = $( "#tab" );

        /** *********** VARIABLES *********** **/
        this.jSonFileFormats = jsonFileFormats || null;
        this.selectFileFormatsList = new Object();

        this.jSonYesNos = jsonYesNos || null;
        this.select_ih2oeList = new Object();
        this.select_io2eList = new Object();
        this.select_io3eList = new Object();
        this.select_ico2eList = new Object();
        this.select_ich4eList = new Object();
        this.select_in2oeList = new Object();
        this.select_irextinctionList = new Object();
        this.select_ibervCList = new Object();
        this.select_iOneTransmissionList = new Object();

        this.jSonObservatories = jsonObservatories || false;
        this.selectObservatoriesList = new Object();
        this.jSonSpectralUnits = jsonSpectralUnits || null;
        this.selectSpectralUnitsList = new Object();
        this.jSonInstrumentalFunctions = jsonInstrumentalFunctions || null;
        this.selectInstrumentalFunctionsList = new Object();
        this.jSonClimatoReferences = jsonClimatoReferences || null;
        this.selectClimatoReferencesList = new Object();
        this.dateTemp = "zz";
        this.nbRequest = 1;
        this.tabActive = false;
        this.numRequest = 1;


        this.language = tapasTexts["language"];
        this.browser = "Firefox";

        if( navigator.userAgent.indexOf( 'Firefox' ) != -1 && parseFloat( navigator.userAgent.substring( navigator.userAgent.indexOf( 'Firefox' ) + 8 ) ) >= 3.6 )
        {
            this.browser = "Firefox";
        }
        else if( navigator.userAgent.indexOf( 'Chrome' ) != -1 && parseFloat( navigator.userAgent.substring( navigator.userAgent.indexOf( 'Chrome' ) + 7 ).split( ' ' )[0] ) >= 15 )
        {
            this.browser = "Chrome";
        }
        else if( navigator.userAgent.indexOf( 'Safari' ) != -1 && navigator.userAgent.indexOf( 'Version' ) != -1 && parseFloat( navigator.userAgent.substring( navigator.userAgent.indexOf( 'Version' ) + 8 ).split( ' ' )[0] ) >= 5 )
        {
            this.browser = "Safari";
        }

        // Buttons
        var submitButton = new Button( {value:tapasTexts["label.submitButton"], parent:this.containerCenter, id:"button_submit", className: "tapas1", classNameText:"tapas1_text", onClick:jQuery.proxy( this.onClickSubmit, this )} );
        this.addRequestButton = new Button( {title:tapasTexts["label.title.add"],value:tapasTexts["label.addButton"], parent:this.containerCenter, id:"button_add", className: "positive", onClick:jQuery.proxy( this.onClickAdd, this )} );
        this.delRequestButton = new Button( {title:tapasTexts["label.title.del"],value:tapasTexts["label.delButton"], parent:this.containerCenter, id:"button_del", className: "negative", onClick:jQuery.proxy( this.onClickDel, this )} );
        this.delRequestButton.disable();

        this.createForm();

        this.tabActive = this.createTab();
        this.divE = $( document.createElement( "div" ) );
        this.divE.attr( {id:"divErrors", class:"errorsForm"} );
        /*var fieldSetE = $( document.createElement( "fieldset" ) );
         fieldSetE.addClass( "cfs3" );
         this.divE.append( fieldSetE );*/

        this.containerForm.append( this.divE );
        //this.containerErrors.hide();
        this.divE.hide();

        /** *********** LOADING *********** **/
        var param = new Object();
        param.id = "loadingForRequest";
        param.parent = this.containerForm;
        param.className = "loading-classic";
        this.loadingRequest = new Loading( param );

        var nbr=1;

        $( '#select_iobservatory_'+this.nbRequest ).bind( 'focus', ["1"], jQuery.proxy(this.locationChoice,this));

        //this.loadingRequest.display();
    },


    // CREATES ********************************************************
    createTab:function()
    {
        var ntab = new Tab( {value:tapasTexts["label.requete"] + " " + this.nbRequest, parent:this.containerTabs, numTab: this.nbRequest, id:"tab_request" + this.nbRequest, className: "tab_class", onClick:jQuery.proxy( this.onClickTab, this )} );
        ntab.active();
        return ntab;
    },


    createCalendar: function( containerCalendar, texte, texte2, inputDateId, inputDateId2, currentDate, isTrToCreate )
    {
        if( isTrToCreate )
        {
            // Create input for date text
            var tr = $( document.createElement( "tr" ) );
            var td1 = $( document.createElement( "td" ) );
            var td2 = $( document.createElement( "td" ) );
            var td3 = $( document.createElement( "td" ) );
            var td4 = $( document.createElement( "td" ) );
            var inputDate = $( document.createElement( "input" ) );
            inputDate.attr( {id:inputDateId, size:"17"} );

            var inputDate2 = $( document.createElement( "input" ) );
            inputDate2.attr( {id:inputDateId2, size:"17"} );

            td1.html( texte );
            td1.attr( { class:"containerLabel" } );
            tr.append( td1 );

            td2.attr( {colspan:3} );
            td2.append( inputDate );
            tr.append( td2 );
            containerCalendar.append( tr );

            td3.html( texte2 );
            td3.attr( { class:"containerLabel" } );
            td3.attr( {colspan:2} );
            tr.append( td3 );

            td4.attr( {colspan:5} );
            td4.append( inputDate2 );
            inputDate2.bind( "change", jQuery.proxy(this.checkDate,this));
            inputDate.bind( "focusin", jQuery.proxy(this.tempDate,this));
            inputDate.bind( "focusout", jQuery.proxy(this.emptyCpyDate,this));
            tr.append( td4 );
            containerCalendar.append( tr );

        }

        // Calendar
        this.calendarFormat = "%Y-%m-%d %H:%i:%s";
        this.calendarConverter = new AnyTime.Converter( { format: this.calendarFormat } );

        AnyTime.picker( inputDateId, { format: this.calendarFormat, firstDOW: 1,
            labelTitle: "Select Date", labelYear: "Year", labelMonth: "Month", labelDayOfMonth: "Day",
            labelHour: "Hour", labelMinute: "Minute", labelSecond: "Second"
        } );

        // Ajout de la date courrante ds le calendrier SI currentDate non précisée
        if( !currentDate )
            currentDate = new Date();


        $( "#" + inputDateId ).val( this.calendarConverter.format( currentDate ) );
        $( "#" + inputDateId ).addClass( "calendar" );

    },


    // CREATES ********************************************************
    createTime: function( containerCalendar, texte, inputDateId, currentTime, isTrToCreate, text2 )
    {
        if( isTrToCreate )
        {

            // Create input for date text
            var tr = $( document.createElement( "tr" ) );
            var td1 = $( document.createElement( "td" ) );
            var td2 = $( document.createElement( "td" ) );
            var td3 = $( document.createElement( "td" ) );
            var inputDate = $( document.createElement( "input" ) );
            inputDate.attr( {id:inputDateId, size:"10"} );

            td1.html( texte );
            td1.attr( { class:"containerLabel" } );
            tr.append( td1 );

            td2.attr( {colspan:1} );
            td2.append( inputDate );
            tr.append( td2 );

            td3.html( text2 );
            td3.attr( { class:"containerLabel2" } );
            tr.append( td3 );

            containerCalendar.append( tr );
        }

        // Time
        this.timeFormat = "%H:%i:%s";
        this.timeConverter = new AnyTime.Converter( { format: this.timeFormat } );

        AnyTime.picker( inputDateId, { format: this.timeFormat, firstDOW: 1,
            labelTitle: "Select hour", labelHour: "Hour", labelMinute: "Minute", labelSecond: "Second"
        } );

        if( !currentTime )
            currentTime = "00:00:00";
        // TODO : voir si besoin de convertir format des heures
//        $( "#" + inputDateId ).val( this.timeConverter.format( currentTime ) );
        $( "#" + inputDateId ).val( currentTime );
        $( "#" + inputDateId ).addClass( "time" );
    },


    createTr: function( texte, inputId, container, textesup, event, champ, ctnb, info )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );

        input.attr( {id: inputId, class:"containerText" + ctnb, size:11} );


        if( event.length > 0 ) input.bind( event, [this, champ], this.angleChoice );


        td1.attr( {class:"containerLabel"} );

        td3.html( textesup );
        td3.attr( {class:"containerLabel2", colspan:3} );
        tr.append( td1 );
        td2.append( input );

        td2.attr( {colspan:2} );

        tr.append( td2 );
        tr.append( td3 );
        container.append( tr );



        var re1 = new RegExp( "isr_" );
        var re2 = new RegExp( "irp_" );

        if( info && (inputId.match( re1 ) || inputId.match( re2 )) )
        {

            var img = $( document.createElement( "img" ) );
            var a = $( document.createElement( "a" ) );
            var div = $( document.createElement( "div" ) );
            img.attr( "src", "resources/images/info.png" );
            img.attr( "width", "19" );
            a.attr( "style", "cursor:pointer" );

            img.bind( "click", [inputId,450,100,this], this.onClickInfos );
            a.append( img );
            div.append( a );

            td1.append( a );
            td1.append( texte );
            tr.append( div );

            if (inputId.match( re2 )) {
                input.css("backgroundColor", "#bfafd6");
                input.attr('disabled','disabled');
            }

        }
        else if( info )
        {
            var img = $( document.createElement( "img" ) );
            var a = $( document.createElement( "a" ) );
            img.attr( "src", "resources/images/info.png" );
            img.attr( "width", "19" );
            a.attr( "style", "cursor:pointer" );
            img.bind( "click", [inputId,450,100,this], this.onClickInfos );
            a.append( img );
            td1.append( a );
            td1.append( texte );

        }


    },


    createTrTxt: function( texte, container )
    {

        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );

        td1.html( texte );
        td1.attr( {class:"containerLabelT", colspan:4} );

        tr.append( td1 );
        container.append( tr );

    },


    createTr2Input: function( texte1, texte2, inputId1, inputId2, container, textesup )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var td4 = $( document.createElement( "td" ) );
        var td5 = $( document.createElement( "td" ) );
        var td6 = $( document.createElement( "td" ) );
        var input1 = $( document.createElement( "input" ) );
        var input2 = $( document.createElement( "input" ) );

        input1.attr( {id: inputId1,class:"containerText",size:11} );
        input2.attr( {id: inputId2,class:"containerText",size:11} );

        td3.html( texte2 );
        td5.html( textesup );
        var img = $( document.createElement( "img" ) );
        var a = $( document.createElement( "a" ) );
        img.attr( "src", "resources/images/info.png" );
        img.attr( "width", "19" );
        a.attr( "style", "cursor:pointer" );
        img.bind( "click", ["spectral_range",450,100,this], this.onClickInfos );
        a.append( img );
        td1.append( a );
        td1.append( texte1 );

        //img.onclick(this.onClickInfos("spectral_range",1200,440));

        td1.attr( {class:"containerLabel"} );
        td3.attr( {class:"containerLabel4"} );
        td5.attr( {class:"containerLabel2"} );

        td2.append( input1 );
        //td2.html( texte2 );
        td4.append( input2 );
        td4.attr( {colspan:2} );
        td5.attr( {colspan:2} );

        tr.append( td1 );
        tr.append( td2 );
        tr.append( td3 );
        tr.append( td4 );
        tr.append( td5 );
        tr.append( td6 );
        container.append( tr );
    },


    createTr3Input: function( texte1, texte2, texte3, texte4, inputId1, inputId2, inputId3, inputId4, container, textesup, textesup2 )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var td4 = $( document.createElement( "td" ) );
        var td5 = $( document.createElement( "td" ) );
        var td6 = $( document.createElement( "td" ) );
        var td7 = $( document.createElement( "td" ) );
        var td8 = $( document.createElement( "td" ) );
        var td9 = $( document.createElement( "td" ) );


        var input1 = $( document.createElement( "input" ) );
        var input2 = $( document.createElement( "input" ) );
        var input3 = $( document.createElement( "input" ) );
        var input4 = $( document.createElement( "input" ) );


        input1.attr( {id: inputId1,class:"containerText",size:14} );
        input2.attr( {id: inputId2,class:"containerText",size:4} );
        input3.attr( {id: inputId3,class:"containerText",size:4} );
        input4.attr( {id: inputId4,class:"containerText",size:4} );

        input1.attr( {disabled: true} );
        input2.attr( {disabled: true} );
        input3.attr( {disabled: true} );
        input4.attr( {disabled: true} );

        input1.css("backgroundColor", "#bfafd6");
        input2.css("backgroundColor", "#bfafd6");
        input3.css("backgroundColor", "#bfafd6");
        input4.css("backgroundColor", "#bfafd6");

        input1.bind( "change", ["2"], jQuery.proxy(this.locationChoice,this));
        input2.bind( "change", ["2"], jQuery.proxy(this.locationChoice,this));
        input3.bind( "change", ["2"], jQuery.proxy(this.locationChoice,this));
        input4.bind( "change", ["2"], jQuery.proxy(this.locationChoice,this));

        td3.html( texte2 );
        td5.html( texte3 );
        td7.html( texte4 );
        td9.html( textesup );



        /*
        var img = $( document.createElement( "img" ) );
        var a = $( document.createElement( "a" ) );
        img.attr( "src", "resources/images/info.png" );
        img.attr( "width", "19" );
        a.attr( "style", "cursor:pointer" );
        img.bind( "click", ["spectral_range",450,100,this], this.onClickInfos );
        a.append( img );
        td1.append( a );*/
        td1.append( texte1 );


        //img.onclick(this.onClickInfos("spectral_range",1200,440));

        td1.attr( {class:"containerLabel"} );
        td3.attr( {class:"containerLabel4"} );
        td5.attr( {class:"containerLabel2"} );
        td7.attr( {class:"containerLabel2"} );
        td9.attr( {class:"containerLabel2"} );



        td2.append( input1 );
        td4.append( input2 );
        td6.append( input3 );
        td8.append( input4 );
        td4.append( textesup2 );

        td2.attr( {colspan:2} );

        tr.append( td1 );
        tr.append( td2 );
        tr.append( td3 );
        tr.append( td4 );
        tr.append( td5 );
        tr.append( td6 );
        tr.append( td7 );
        tr.append( td8 );
        tr.append( td9 );

        container.append( tr );
    },


    createTrList: function( texte, inputId, index, container, type, info, event )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );
        var champ = "";

        var div = $( document.createElement( "div" ) );

        input.attr( {id: inputId} );

        if( 'format' == type )
        {
            this.displaySelect( td2, inputId, index, this.jSonFileFormats, this.selectFileFormatsList, false, null );
            info = true;
            champ = "iformat_";
        }
        else
        if( 'yesno' == type )
        {
            if( (/^(ih2oe_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_ih2oeList, false, "yesNos" );
            else if( (/^(io2e_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_io2eList, false, "yesNos" );
            else if( (/^(io3e_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_io3eList, false, "yesNos" );
            else if( (/^(ico2e_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_ico2eList, false, "yesNos" );
            else if( (/^(ich4e_[1-9]+)$/.test( inputId )  ) )
                    this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_ich4eList, false, "yesNos" );
            else if( (/^(in2oe_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_in2oeList, false, "yesNos" );
            else if( (/^(iOneTransmission_[1-9]+)$/.test( inputId )  ) )
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_iOneTransmissionList, false, "yesNos" );
            else if( (/^(irextinction_[1-9]+)$/.test( inputId )  ) )
            {

                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_irextinctionList, false, "yesNos" );
                info = true;
                champ = inputId;
            }
            else if( (/^(ibervC_[1-9]+)$/.test( inputId )  ) )
            {
                this.displaySelect( td2, inputId, index, this.jSonYesNos, this.select_ibervCList, false, "yesNos" );
                info = true;
                champ = inputId;

            }
        }
        else if( 'observatories' == type )
        {
            this.displaySelect1( td2, inputId, index, this.jSonObservatories, this.selectObservatoriesList, true, "observatories" );
            //this.displaySelect( td2, inputId, index, this.jSonObservatories, this.selectObservatoriesList, true, "observatories" );
            champ = "iobservatory_";
            //input.bind( 'click', [this, 'select_iobservatory_1'], this.locationChoice );
        }
        else if( 'spectralUnit' == type )
        {
            this.displaySelect( td2, inputId, index, this.jSonSpectralUnits, this.selectSpectralUnitsList, true, "spectralUnits" );
            info = true;

            champ = "ispectral_choice_";
        }
        else if( 'ilsf' == type )
        {
            this.displaySelect( td2, inputId, index, this.jSonInstrumentalFunctions, this.selectInstrumentalFunctionsList, false, "instrumentalFunctions" );
            info = true;
            champ = "ifunction_";
        }
        else if( 'climatoReference' == type )
        {
            this.displaySelect( td2, inputId, index, this.jSonClimatoReferences, this.selectClimatoReferencesList, false, "climatoReferences" );
            info = true;
            champ = "icr_";
        }



        td1.attr( {class:"containerLabel"} );
        tr.append( td1 );




        if( info )
        {
            var img = $( document.createElement( "img" ) );
            var a = $( document.createElement( "a" ) );
            img.attr( "src", "resources/images/info.png" );
            img.attr( "width", "19" );
            a.attr( "style", "cursor:pointer" );
            img.bind( "click", [champ,450,100,this], this.onClickInfos );
            a.append( img );
            div.append( a );


            td2.attr( {colspan:10} );
            td1.append( a );
            td1.append( texte );

            tr.append( td2 );

        }
        else
        {
            td1.append( texte );
            td2.attr( {colspan:3} );
            tr.append( td2 );
        }
        container.append( tr );

    },


    // REQUESTS ********************************************************
    requestCreateXML: function()
    {
        var tapasForm = this.createTapasObject();
        //passage de javascript a json grace au jquery
        var jsonTapasForm = $.toJSON( tapasForm );


        if( jsonTapasForm )
            $.ajax( {
                url: "data?methodName=createUserRequest&jsonTapas=" + jsonTapasForm,
                success:jQuery.proxy( this.handleCreateXML, this ),
                error: jQuery.proxy( this.showErrors, this )
            } );

    },


    // HANDLES ******************************************************** = retours ajax
    handleCreateXML: function( result )
    {
        this.loadingRequest.hide();
        //this.loadingRequest.display();

        var res = jQuery.parseJSON( result ).result;

    },


    // EVENTS ********************************************************
    onClickInfos: function( param )
    {

        var parametre = param.data[0];
        var width = param.data[1];
        var height = param.data[2];
        var context = param.data[3];

        if( "spectral_range" == parametre )
        {
            width = 600;
            height = 120;
            var titre = "D&eacute;finition de l'intervalle spectral pour le calcul.";
            var pageInfo = "resources/doc/infosSpectralRange_fr.txt";

            if( "fr" != context.language )
            {
                titre = "Definition of spectral interval for the computation.";
                pageInfo = "resources/doc/infosSpectralRange_en.txt";
                width = 600;
                height = 100;
            }

        }

        if( "ispectral_choice_" == parametre )
        {
            var titre = "Unit&eacute; spectrale";
            var pageInfo = "resources/doc/infosSpectralUnit_fr.txt";
            width = 600;
            height = 450;
            if( "fr" != context.language )
            {
                titre = "Spectral unit";
                pageInfo = "resources/doc/infosSpectralUnit_en.txt";
                width = 500;
                height = 450;
            }
        }

        var re = new RegExp( "irp_" );
        if( parametre.match( re ) )
        {
            var titre = "R&eacute;solution";
            var pageInfo = "resources/doc/infosResolution_fr.txt";
            width = 600;
            height = 200;
            if( "fr" != context.language )
            {
                titre = "Resolution power";
                pageInfo = "resources/doc/infosResolution_en.txt";
                width = 500;
                height = 200;
            }
        }

        var re = new RegExp( "isr_" );
        if( parametre.match( re ) )
        {
            var titre = "Taux d'&eacute;chantillonnage";
            var pageInfo = "resources/doc/infosSamplingRatio_fr.txt";
            width = 600;
            height = 100;
            if( "fr" != context.language )
            {
                titre = "Sampling ratio";
                pageInfo = "resources/doc/infosSamplingRatio_en.txt";
                width = 500;
                height = 100;
            }
        }

        var re = new RegExp( "ibervC_" );
        if( parametre.match( re ) )
        {
            var titre = "Correction BERV";
            var pageInfo = "resources/doc/infosBERV_fr.txt";
            width = 950;
            height = 700;
            if( "fr" != context.language )
            {
                titre = "BERV correction";
                pageInfo = "resources/doc/infosBERV_en.txt";
                width = 950;
                height = 680;
            }
        }

        var re = new RegExp( "ira_" );
        if( parametre.match( re ) )
        {
            var titre = "LOS Ascension Droite";
            var pageInfo = "resources/doc/infosLOSRA_fr.txt";
            width = 600;
            height = 150;
            if( "fr" != context.language )
            {
                titre = "LOS Right Ascension";
                pageInfo = "resources/doc/infosLOSRA_en.txt";
                width = 500;
                height = 150;
            }
        }

        var re = new RegExp( "ide_" );
        if( parametre.match( re ) )
        {
            var titre = "LOS D&eacute;clinaison";
            var pageInfo = "resources/doc/infosLOSD_fr.txt";
            width = 600;
            height = 100;
            if( "fr" != context.language )
            {
                titre = "LOS Declination";
                pageInfo = "resources/doc/infosLOSD_en.txt";
                width = 600;
                height = 100;
            }
        }

        var re = new RegExp( "iza_" );
        if( parametre.match( re ) )
        {
            var titre = "Angle z&eacute;nithal";
            var pageInfo = "resources/doc/infosZenithalAngle_fr.txt";
            width = 600;
            height = 100;
            if( "fr" != context.language )
            {
                titre = "Zenithal angle";
                pageInfo = "resources/doc/infosZenithalAngle_en.txt";
                width = 600;
                height = 100;
            }
        }

        var re = new RegExp( "isr_" );
        if( parametre.match( re ) )
        {
            var titre = "Taux d'&eacute;chantillonnage";
            var pageInfo = "resources/doc/infosSamplingRatio_fr.txt";
            width = 600;
            height = 150;
            if( "fr" != context.language )
            {
                titre = "Sampling Ratio";
                pageInfo = "resources/doc/infosSamplingRatio_en.txt";
                width = 500;
                height = 150;
            }
        }

        var re = new RegExp( "irextinction_" );
        if( parametre.match( re ) )
        {
            var titre = "S&eacute;lection des composants atmosph&eacute;riques";
            var pageInfo = "resources/doc/infosSpecies_fr.txt";
            width = 600;
            height = 350;
            if( "fr" != context.language )
            {
                titre = "Selection of atmospheric constituents";
                pageInfo = "resources/doc/infosSpecies_en.txt";
                width = 600;
                height = 360;
            }
        }

        if( "icr_" == parametre )
        {
            var titre = "Mod&egrave;le atmosph&eacute;rique";
            var pageInfo = "resources/doc/infosAtmosphericModel_fr.txt";
            width = 600;
            height = 400;
            if( "fr" != context.language )
            {
                titre = "Atmospheric model";
                pageInfo = "resources/doc/infosAtmosphericModel_en.txt";
                width = 500;
                height = 400;
            }
        }

        if( "iobservatory_" == parametre )
        {
            var titre = "Observatoire";
            var pageInfo = "resources/doc/infosObservatory_fr.txt";
            width = 600;
            height = 100;
            if( "fr" != context.language )
            {
                titre = "Observatory";
                pageInfo = "resources/doc/infosObservatory_en.txt";
                width = 500;
                height = 100;
            }
        }

        if( "iformat_" == parametre )
        {
            var titre = "Format fichier";
            var pageInfo = "resources/doc/infosFileFomat_fr.txt";
            width = 600;
            height = 100;
            if( "fr" != context.language )
            {
                titre = "File format";
                pageInfo = "resources/doc/infosFileFomat_en.txt";
                width = 500;
                height = 80;
            }
        }

        if( "ifunction_" == parametre )
        {
            var titre = "Fonction instrumentale";
            var pageInfo = "resources/doc/infosInstrumentalFunction_fr.txt";
            width = 600;
            height = 230;
            if( "fr" != context.language )
            {
                titre = "Instrumental function";
                pageInfo = "resources/doc/infosInstrumentalFunction_en.txt";
                width = 500;
                height = 240;
            }
        }


        var $dialog = $( '<div></div>' )
                .load( pageInfo )
                .dialog( {
                             autoOpen: false,
                             title:titre,
                             height:height,
                             width:width
                         } );

        $dialog.dialog( 'open' );

    },

    onClickSubmit: function()
    {
        if( this.validFields() )
        {
            this.divE.hide();
            if( confirm( tapasTexts["confirm"] ) )
            {
                this.loadingRequest.display();
                this.requestCreateXML();
            }
        }
    },


    onClickAdd: function()
    {
        this.divE.hide();
        this.nbRequest++;

        //tabs
        $( ".tab_class" ).removeClass( "activated" );
        this.tabActive = this.createTab();
        this.numRequest = this.tabActive.numTab;

        //formulaires
        $( ".divAll" ).hide();
        this.createForm();

        this.updateButtons();
    },


    onClickDel: function()
    {
        if( confirm( tapasTexts["label.confirm.del"] ) )
        {
            var numCurrent = this.numRequest;

            var z = 1;

            //suppression onglet et form et controles calendrier caché
            $( "#all_" + numCurrent ).remove();
            $( "#tab_request" + numCurrent ).remove();
            AnyTime.noPicker( "iobservation_date_" + numCurrent );
            AnyTime.noPicker( "iobservation_cpydate_" + numCurrent );
            AnyTime.noPicker( "ira_" + numCurrent );

            this.tabActive.numTab = "1";
            this.numRequest = "1";

            this.selectClimatoReferencesList[numCurrent] = null;

            for( var i = 1; i <= this.nbRequest; i++ )
            {
                if( i > numCurrent )
                {
                    z = i - 1;
                    document.getElementById( "all_" + i ).id = "all_" + z;
                    $( "#tab_request" + i ).html( "Request " + z );
                    //$( "#tab_request" + i ).html( "toto");
                    $( "#tab_request" + i ).attr( {name:z} );
                    $( "#tab_request" + i ).attr( {id:"tab_request" + z} );       //this.angleChoice
                    $( "#tabObservation_" + i ).attr( {id:"tabObservation_" + z} );
//                    $( "#select_iobservatory_" + i ).attr( {id:"select_iobservatory_" + z} );
                    this.selectObservatoriesList[z] = this.selectObservatoriesList[i];
                    this.selectObservatoriesList[i] = null;
//                    $( "#select_ispectral_choice_" + i ).attr( {id:"select_ispectral_choice_" + z} );
                    this.selectSpectralUnitsList[z] = this.selectSpectralUnitsList[i];
                    this.selectSpectralUnitsList[i] = null;
                    $( "#iminspectral_ranger_" + i ).attr( {id:"iminspectral_ranger_" + z} );
                    $( "#imaxspectral_ranger_" + i ).attr( {id:"imaxspectral_ranger_" + z} );
//                    $( "#select_ifunction_" + i ).attr( {id:"select_ifunction_" + z} );
                    this.selectInstrumentalFunctionsList[z] = this.selectInstrumentalFunctionsList[i];
                    this.selectInstrumentalFunctionsList[i] = null;
//                    $( "#select_icr_" + i ).attr( {id:"select_icr_" + z} );
                    this.selectClimatoReferencesList[z] = this.selectClimatoReferencesList[i];
                    this.selectClimatoReferencesList[i] = null;
                    // le $ n'intervient qu en html. $() remplace le document.element
                    $( "#ide_" + i ).attr( {id:"ide_" + z} );
                    $( "#iza_" + i ).attr( {id:"iza_" + z} );
                    $( "#irp_" + i ).attr( {id:"irp_" + z} );
                    $( "#isr_" + i ).attr( {id:"isr_" + z} );
                    $( "#ira_" + i ).attr( {id:"ira_" + z} );
//                    $( "#select_iformat_" + i ).attr( {id:"select_iformat_" + z} );
                    this.selectFileFormatsList[z] = this.selectFileFormatsList[i];
                    this.selectFileFormatsList[i] = null;
//                    $( "#select_irextinction_" + i ).attr( {id:"select_irextinction_" + z} );
                    this.select_irextinctionList[z] = this.select_irextinctionList[i];
                    this.select_irextinctionList[i] = null;
//                    $( "#select_ih2oe_" + i ).attr( {id:"select_ih2oe_" + z} );
                    this.select_ih2oeList[z] = this.select_ih2oeList[i];
                    this.select_ih2oeList[i] = null;
//                    $( "#select_io2e_" + i ).attr( {id:"select_io2e_" + z} );
                    this.select_io2eList[z] = this.select_io2eList[i];
                    this.select_io2eList[i] = null;
//                    $( "#select_io3e_" + i ).attr( {id:"select_io3e_" + z} );
                    this.select_io3eList[z] = this.select_io3eList[i];
                    this.select_io3eList[i] = null;
//                    $( "#select_ico2e_" + i ).attr( {id:"select_ico2e_" + z} );
                    this.select_ico2eList[z] = this.select_ico2eList[i];
                    this.select_ico2eList[i] = null;

                    this.select_ich4eList[z] = this.select_ich4eList[i];
                    this.select_ich4eList[i] = null;

                    this.select_in2oeList[z] = this.select_in2oeList[i];
                    this.select_in2oeList[i] = null;

                    this.select_iOneTransmissionList[z] = this.select_iOneTransmissionList[i];
                    this.select_iOneTransmissionList[i] = null;

                    this.select_ibervCList[z] = this.select_ibervCList[i];
                    this.select_ibervCList[i] = null;

                    // Supression du calendrier puis re-création en insérant l'ancienne date
                    var oldDate = this.calendarConverter.parse( $( "#iobservation_date_" + i ).val() );
                    AnyTime.noPicker( "iobservation_date_" + i );

                    if (!isEmpty($( "#iobservation_cpydate_" + i ).val())) {
                        var oldDate2 = this.calendarConverter.parse( $( "#iobservation_cpydate_" + i ).val() );
                        AnyTime.noPicker( "iobservation_cpydate_" + i );
                    }

                    //this.createCalendar( $( "#tabObservation_" + z ), tapasTexts["label.datemesure"], "iobservation_date_" + z, oldDate, false );

                    $( "#iobservation_date_" + i ).attr( {id:"iobservation_date_" + z} );
                    $( "#iobservation_cpydate_" + i ).attr( {id:"iobservation_cpydate_" + z} );
                    this.createCalendar( $( "#tabObservation_" + z ), tapasTexts["label.datemesure"], tapasTexts["label.cpydatemesure"], "iobservation_date_" + z, "iobservation_cpydate_" + z, oldDate, false );



                    // Idem pour les heures !!!
                    // TODO : voir si besoin de parser les heures ou non
//                    var oldTime = this.timeConverter.parse( $( "#ira_" + i ).val() );
                    /*var oldTime = $( "#ira_" + i ).val();
                     AnyTime.noPicker( "ira_" + i );
                     this.createTime( $( "#tabObservation_" + z ), tapasTexts["label.ira"], "ira_" + z, oldTime, false,"j2000" );
                     $( "#ira_" + i ).attr( {id:"ira_" + z} );*/
                }
            }

            this.nbRequest--;

            // Mise à jour des boutons
            this.updateButtons();

            //tabs
            $( ".tab_class" ).removeClass( "activated" );
            $( "#tab_request1" ).addClass( "activated" );

            //formulaires
            $( ".divAll" ).hide();
            $( "#all_1" ).show();
        }
    },


    onClickTab: function( event )
    {
        var realTabId = $( "#" + event.currentTarget.id ).attr( "name" );
        var clickedDiv = event.data;

        //tabs
        $( ".tab_class" ).removeClass( "activated" );
        clickedDiv.divContainer.addClass( "activated" );

        //forms
        $( ".divAll" ).hide();
        $( "#all_" + realTabId ).show();

        this.numRequest = realTabId;
        this.tabActive.numTab = realTabId;

        this.updateButtons();
    },


    // OTHERS ********************************************************
    // General method to display select
    displaySelect: function( container, id, index, jsonList, selectList, nullValueIsNeeded, contentManage )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.parent = container;
        var select = new Select( paramSelect );


        //select.add( "tt", "bob " + tapasTexts["text.select"] + " --",this.ifunctionChoice);

        if( nullValueIsNeeded )
            select.add( "-1", "-- " + tapasTexts["text.select"] + " --" );
        jQuery.each( jsonList, jQuery.proxy( function ( i, jsonElement )
        {
            switch( contentManage )
            {
                case "observatories":
                    select.add( jsonElement.id, jsonElement.name );
                    break;
                case "spectralUnits":
                    select.add( jsonElement.value, tapasTexts[jsonElement.value] );
                    break;
                case "instrumentalFunctions" :
                    select.add( jsonElement.value, tapasTexts[jsonElement.text],jQuery.proxy(this.ifunctionChoice,this) );     // passe le gros this
                    break;
                case "climatoReferences" :
                case "yesNos" :
                    select.add( jsonElement.value, tapasTexts[jsonElement.text] );
                    break;
                default:
                    select.add( jsonElement.value, jsonElement.text );

                    break;
            }
        }, this ) );
        select.selectFirst( false );
        selectList[index] = select;
    },

    createAutoCompleteMenuForRegions: function()
    {

        $( "#select_iobservatory_" + this.nbRequest ).autocomplete( {
            source: this.listObs,
            appendTo: "#regionContent" + this.nbRequest,
            minLength: 0,
            autoFocus: true,
            autoSelect: true,
            select: jQuery.proxy( function( event, ui )
            {
                this.regionLabel = ui.item.value;
            }, this )
        } ).focus( function( event )
        {
            $( this ).autocomplete( "search", "" );
        } );

        //$( "#regionTags" ).focus();
    },


// OTHERS ********************************************************
    // General method to display select
    displaySelect1: function( container, id, index, jsonList, selectList, nullValueIsNeeded, contentManage )
    {
        var iselect = $( document.createElement( "select" ) );
        var option = document.createElement( "option" );

        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.parent = container;

        var observatoryArray = new Array();
        this.listObs = new Array();


        //var bob =$('<div id="region" class="containerField"><div class="containerTitle"><div class="containerTitleText">Region</div><div class="containerTitleClose"><img src="img/close.png"></div></div><div class="containerRegion"><input id="regionTags" size="23"/></div><div id="regionContent"></div></div> ');
        var bob = $( '<div class="containerField"><input id="select_' + id + '" size="42"/></div><div id="regionContent' + this.nbRequest + '" class="regionContent"></div> ' );

        var option = new Option();
        option.text = "-- " + tapasTexts["text.select"] + " --";
        option.value = "-1";


        jQuery.each( jsonList, jQuery.proxy( function ( i, jsonElement )
        {
            //ajouter fonction

            /*var option = new Option();
             option.text = jsonElement.name;
             option.value = jsonElement.id;*/
            //observatoryArray.push(jsonElement.name);
            this.listObs.push( jsonElement.name );
            //console.log(option.value+"-"+option.text);
            //iselect.append(option);

        }, this ) );
        //iselect.selectFirst( false );
        /*selectList[index] = select;*/
        //container.append(iselect);

        container.append( bob );
        selectList[index] = "select_" + id;


    },


    showErrors: function( result )
    {
        //this.containerErrors.show();
        // this.containerErrors.html( tapasTexts[result.responseText] );
    },

    createForm: function()
    {

        var divAll = $( document.createElement( "div" ) );
        divAll.attr( {id:"all_" + this.nbRequest, class:"divAll"} );


        //Creation div
        var divPreference = $( document.createElement( "div" ) );
        var tabPreference = $( document.createElement( "table" ) );
        tabPreference.attr( {cellspacing:3} );

        var divObservation = $( document.createElement( "div" ) );
        var tabObservation = $( document.createElement( "table" ) );
        //tabObservation.attr({border:1});
        tabObservation.attr( {id:"tabObservation_" + this.nbRequest, cellspacing:3} );


        var divAtmosphere = $( document.createElement( "div" ) );
        var tabAtmosphere = $( document.createElement( "table" ) );


        var fieldSetObservation = $( document.createElement( "fieldset" ) );
        fieldSetObservation.addClass( "cfs1" );
        divObservation.append( fieldSetObservation );

        var legendObservation = $( document.createElement( "legend" ) );
        legendObservation.html( "Observation" );
        fieldSetObservation.append( legendObservation );
        legendObservation.addClass( "containerField" );

        var fieldSetPreference = $( document.createElement( "fieldset" ) );
        fieldSetPreference.addClass( "cfs2" );
        divPreference.append( fieldSetPreference );

        var legendPreference = $( document.createElement( "legend" ) );
        legendPreference.html( tapasTexts["label.preferences"] );
        fieldSetPreference.append( legendPreference );
        legendPreference.addClass( "containerField" );

        fieldSetObservation.append( tabObservation );
        divObservation.addClass( "divObservation" );
        divAll.append( divObservation );

        divAtmosphere.append( tabAtmosphere );
        //divAtmosphere.addClass("divAtmosphere");
        //this.containerForm.append( divAtmosphere );
        fieldSetObservation.append( divAtmosphere );

        fieldSetPreference.append( tabPreference );
        divPreference.addClass( "divPreference" );
        divAll.append( divPreference );

        this.containerForm.append( divAll );
        this.containerForm.append( this.divE );
        //this.tabInput = new Array(3);

        this.createTrList( tapasTexts["label.format"], "iformat_" + this.nbRequest, this.nbRequest, tabPreference, 'format',false,"" );
        this.createTrList( tapasTexts["label.berv"], "ibervC_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.era"], "irextinction_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.eh2o"], "ih2oe_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.eo3"], "io3e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.eo2"], "io2e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.eco2"], "ico2e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.ech4"], "ich4e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.en2o"], "in2oe_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );
        this.createTrList( tapasTexts["label.onetransmission"], "iOneTransmission_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno',false,"" );



        this.createTrList( tapasTexts["label.observatory"], "iobservatory_" + this.nbRequest, this.nbRequest, tabObservation, 'observatories', true, "" );
        this.createTrTxt( tapasTexts["label.or"], tabObservation );
        this.createTr3Input( tapasTexts["label.locality"], tapasTexts["label.altitude"], tapasTexts["label.latitude"],tapasTexts["label.longitude"],"ilocality_" + this.nbRequest, "ialtitude_" + this.nbRequest, "ilatitude_" + this.nbRequest, "ilongitude_" + this.nbRequest , tabObservation, "[decimal]"," <b>m</b>" );

        this.createCalendar( tabObservation, tapasTexts["label.datemesure"], tapasTexts["label.cpydatemesure"], "iobservation_date_" + this.nbRequest, "iobservation_cpydate_" + this.nbRequest, false, true );


        //unite
        this.createTrList( tapasTexts["label.spectralUnit"], "ispectral_choice_" + this.nbRequest, this.nbRequest, tabObservation, 'spectralUnit', false, "" );
        this.createTr2Input( tapasTexts["label.spectralRange"], tapasTexts["label.to"], "iminspectral_ranger_" + this.nbRequest, "imaxspectral_ranger_" + this.nbRequest, tabObservation, "[350,2500] nm" );

        //fonction instrumentale
        this.createTrList( tapasTexts["label.ifunction"], "ifunction_" + this.nbRequest, this.nbRequest, tabObservation, "ilsf", false, "select");
        //reference climato
        //this.createTrList( tapasTexts["label.climato"], "icr", tabAtmosphere, "climatoReference" );
        this.createTrList( tapasTexts["label.climato"], "icr_" + this.nbRequest, this.nbRequest, tabObservation, "climatoReference", false, "");

        this.createTr( tapasTexts["label.resolution"], "irp_" + this.nbRequest, tabObservation, "", "", "", "", true );
        this.createTr( tapasTexts["label.ratio"], "isr_" + this.nbRequest, tabObservation, "", "", "", "", true );

        this.createTr( tapasTexts["label.ira"], "ira_" + this.nbRequest, tabObservation, "hh:mm:ss (J2000)", "keypress", "ra", "2", true );
        //this.createTime( tabObservation, tapasTexts["label.ira"], "ira_" + this.nbRequest, false, true,"hh:mm:ss (J2000)" );
        this.createTr( tapasTexts["label.ide"], "ide_" + this.nbRequest, tabObservation, "deg:':''", "keypress", "de", "2", true );
        this.createTrTxt( tapasTexts["label.or"], tabObservation );
        this.createTr( tapasTexts["label.iza"], "iza_" + this.nbRequest, tabObservation, "[0,90] &deg;", "keypress", "za", "2", true );

        this.createAutoCompleteMenuForRegions();

        this.initRequestFields();




        //jQuery.proxy permet d'envoyer le contexte this courant

    },



    createTapasObject: function()
    {

        var requests = new Array();
        var i = 1;



        for( var i = 1; i <= this.nbRequest; i++ )
        {
            // PREFERENCE
            var preference = new Object();

            preference.format = new Object();
            //toutes les valeurs possibles
            preference.format.firstValue = this.selectFileFormatsList[i].getValuesInString();
            //la valeur selectionnee
            preference.format.secondValue = this.selectFileFormatsList[i].getValue();

            preference.rayleighExtinction = new Object();
            preference.rayleighExtinction.firstValue = this.select_irextinctionList[i].getValuesInString();
            preference.rayleighExtinction.secondValue = this.select_irextinctionList[i].getValue();

            preference.h2oExtinction = new Object();
            preference.h2oExtinction.firstValue = this.select_ih2oeList[i].getValuesInString();
            preference.h2oExtinction.secondValue = this.select_ih2oeList[i].getValue();

            preference.o3Extinction = new Object();
            preference.o3Extinction.firstValue = this.select_io3eList[i].getValuesInString();
            preference.o3Extinction.secondValue = this.select_io3eList[i].getValue();

            preference.o2Extinction = new Object();
            preference.o2Extinction.firstValue = this.select_io2eList[i].getValuesInString();
            preference.o2Extinction.secondValue = this.select_io2eList[i].getValue();

            preference.co2Extinction = new Object();
            preference.co2Extinction.firstValue = this.select_ico2eList[i].getValuesInString();
            preference.co2Extinction.secondValue = this.select_ico2eList[i].getValue();

            preference.ch4Extinction = new Object();
            preference.ch4Extinction.firstValue = this.select_ich4eList[i].getValuesInString();
            preference.ch4Extinction.secondValue = this.select_ich4eList[i].getValue();

            preference.n2oExtinction = new Object();
            preference.n2oExtinction.firstValue = this.select_in2oeList[i].getValuesInString();
            preference.n2oExtinction.secondValue = this.select_in2oeList[i].getValue();

            preference.bervCorrection = new Object();
            preference.bervCorrection.firstValue = this.select_ibervCList[i].getValuesInString();
            preference.bervCorrection.secondValue = this.select_ibervCList[i].getValue();

            preference.oneTransmission = new Object();
            preference.oneTransmission.firstValue = this.select_iOneTransmissionList[i].getValuesInString();
            preference.oneTransmission.secondValue = this.select_iOneTransmissionList[i].getValue();


            // OBSERVATION
            var observatory = new Object();
            //observatory.id = "European Southern Obs R La Serena Cerro La Silla";//this.selectObservatoriesList[i].getValue();
            //observatory.id = this.selectObservatoriesList[i].getValue();
            //observatory.id = 2;
            observatory.name = $( "#select_iobservatory_" + i ).val();


            var location = new Object();
            location.name = $( "#ilocality_" + i ).val();
            location.longitude = $( "#ilongitude_" + i ).val();
            location.latitude = $( "#ilatitude_" + i ).val();
            location.altitude = $( "#ialtitude_" + i ).val();
            location.shortName = $( "#ilocality_" + i ).val();

            // Los
            var los = new Object();

            //if ($( "#iza_" + i ).val().toString() != null)
            los.zenithAngle = $( "#iza_" + i ).val();
            //else {
            los.raJ2000 = $( "#ira_" + i ).val();
            los.decJ2000 = $( "#ide_" + i ).val();
            //}


            //los.raJ2000 = "22:22:22";//$( "#ira_" + i ).val();
            //los.decJ2000 = "22:22:22";//$( "#ide_" + i ).val();
            //los.zenithAngle = "12";//$( "#iza_" + i ).val("12");


            // Instrument
            var instrument = new Object();
            instrument.ilsfChoice = new Object();
            instrument.ilsfChoice.firstValue = "-1,0,1";//this.selectInstrumentalFunctionsList[i].getValuesInString();
            instrument.ilsfChoice.secondValue = this.selectInstrumentalFunctionsList[i].getValue();

            this.selectSpectralUnitsList[i].remove( "-1" );
            instrument.spectralChoice = new Object();
            instrument.spectralChoice.firstValue = this.selectSpectralUnitsList[i].getValuesInString();
            instrument.spectralChoice.secondValue = this.selectSpectralUnitsList[i].getValue();

            instrument.spectralRange = $( "#iminspectral_ranger_" + i ).val() + ' ' + $( "#imaxspectral_ranger_" + i ).val();

            instrument.resolvingPower = new Object();
            instrument.resolvingPower.firstValue = "0";
            instrument.resolvingPower.secondValue = $( "#irp_" + i ).val();

            instrument.samplingRatio = new Object();
            instrument.samplingRatio.firstValue = "0";
            instrument.samplingRatio.secondValue = $( "#isr_" + i ).val();

            var observation = new Object();

            if (!isEmpty($( "#iobservation_cpydate_" + i ).val()) && isDate($("#iobservation_cpydate_" + i ).val()) )
            {
                observation.date = this.calendarConverter.parse( $( "#iobservation_cpydate_" + i ).val() ).getTime();
            }
            else
            {
                observation.date = this.calendarConverter.parse( $( "#iobservation_date_" + i ).val() ).getTime();
            }


            observation.observatory = observatory;

            observation.location = location;

            observation.los = los;
            observation.instrument = instrument;

            // ATMOSPHERE
            var atmosphere = new Object();

            atmosphere.reference = new Object();
            atmosphere.reference.firstValue = this.selectClimatoReferencesList[i].getValuesInString();
            atmosphere.reference.secondValue = this.selectClimatoReferencesList[i].getValue();


            // REQUEST
            var request = new Object();
            request.id = i;
            request.preference = preference;
            request.observation = observation;
            request.atmosphere = atmosphere;

            requests[i - 1] = request;
        }

        // TAPAS
        var tapas = new Object();
        tapas.requests = requests;
        return tapas;
    },

    validFields: function()
    {

        for( var i = 1; i <= this.nbRequest; i++ )
        {

            var chaine = tapasTexts["text.erreur.saisie"] + " " + i + "<br>";
            var testOk1 = false;
            var testOk2 = false;
            var testOk3 = false;

            testOk1 = isDate( $( "#iobservation_cpydate_" + this.nbRequest ).val() ) || isEmpty( $( "#iobservation_cpydate_" + this.nbRequest ).val() );
            if( !testOk1 )
            {
                this.divE.hide();
                this.divE.html( chaine + " : " + tapasTexts["text.errcpydate"] );
                this.divE.show();
                return false;
            }


            //var testOk = isSup( this.selectObservatoriesList[i].getValue(), 0 );
            var testOk = isEmpty( $( "#select_iobservatory_" + i ).val() ) || this.listObs.indexOf( $( "#select_iobservatory_" + i ).val() ) < 0;
            testOk2 = !isEmpty( $( "#ilocality_" + i ).val() ) && isValidNum( $( "#ialtitude_" + i ).val() ) && isValidNum( $( "#ilatitude_" + i ).val() ) && isValidNum( $( "#ilongitude_" + i ).val() )

            if( testOk && !testOk2)
            {
                this.divE.hide();
                this.divE.html( chaine + " " + tapasTexts["text.selectlocation"] );
                this.divE.show();
                return false;
            }

            testOk = isDiff( this.selectSpectralUnitsList[i].getValue(), -1 );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.spectralUnit"] + " : " + tapasTexts["text.toselect"] );
                this.divE.show();
                return false;
            }

            testOk = isValidRange( $( "#iminspectral_ranger_" + i ).val(), $( "#imaxspectral_ranger_" + i ).val(), this.selectSpectralUnitsList[i].getValue() );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.spectralRange"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            /*testOk = isDeg( $( "#ide_" + i ).val() );
             if( !testOk )
             {
             this.divE.html( chaine + tapasTexts["label.ide"] + " : " + tapasTexts["text.badvalue"] );
             this.divE.show();
             return false;
             } */


            testOk = isBetween( $( "#iza_" + i ).val(), 0, 90 );
            testOk1 = isValidNum( $( "#iza_" + i ).val() );
            testOk2 = isDeg( $( "#ide_" + i ).val() );
            testOk3 = isHourDeg( $( "#ira_" + i ).val() );
            if( !((testOk && testOk1) || (testOk2 && testOk3)) )
            {
                if( !(testOk && testOk1) )
                    this.divE.html( chaine + "LOS : " + tapasTexts["text.badvalue"] );
                else
                    this.divE.html( chaine + tapasTexts["label.iza"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            /*testOk = isBetween( $( "#iza_" + i ).val(), 0, 90 );
             if( !testOk )
             {
             this.divE.html( chaine + tapasTexts["label.iza"] + " : " + tapasTexts["text.badvalue"] );
             this.divE.show();
             return false;
             } */


            testOk = isValidNum( $( "#irp_" + i ).val() );
            testOk2 = isSupS( this.selectInstrumentalFunctionsList[i].getValue() , -1 );


            if (testOk2)
            {
                if( !testOk )
                {
                    this.divE.html( chaine + tapasTexts["label.resolution"] + " : " + tapasTexts["text.badvalue"] );
                    this.divE.show();
                    return false;
                }

                testOk = isSup( $( "#irp_" + i ).val(), 1 );
                if( !testOk )
                {
                    this.divE.html( chaine + tapasTexts["label.resolution"] + " : " + tapasTexts["text.badvalue"] );
                    this.divE.show();
                    return false;
                }
            }


            testOk = isValidNum( $( "#isr_" + i ).val() );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.ratio"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }

            testOk = isSup( $( "#isr_" + i ).val(), 1 );
            if( !testOk )
            {
                this.divE.html( chaine + tapasTexts["label.ratio"] + " : " + tapasTexts["text.badvalue"] );
                this.divE.show();
                return false;
            }
        }

        return true;
    },



    updateButtons: function()
    {
        if( 1 < this.nbRequest )
            this.delRequestButton.enable();
        else
            this.delRequestButton.disable();

        if( 9 <= this.nbRequest )
            this.addRequestButton.disable();
        else
            this.addRequestButton.enable();
    },



    angleChoice: function( params )
    {

        var context = params.data[0];
        var champ = params.data[1];
        var indice = context.nbRequest;
        if( champ == "za" )
        {
            $( "#ira_" + indice ).val( "" );
            $( "#ide_" + indice ).val( "" );
            //}
        }
        else
        {
            $( "#iza_" + indice ).val( "" );
        }

    },


    ifunctionChoice: function()
    {
        //this.selectInstrumentalFunctionsList[indice].select(this.selectInstrumentalFunctionsList[indice-1].getValue(),false);
        //var context = params.data[0];
        //var champ = params.data[1];
        var valeur = this.selectInstrumentalFunctionsList[this.nbRequest].getValue();

        if ( valeur == -1 ) {
            $( "#irp_" + this.nbRequest ).val("");
            $( "#irp_" + this.nbRequest ).css("backgroundColor", "#bfafd6");
            $( "#irp_" + this.nbRequest ).attr('disabled','disabled');
        }
        else {
            $( "#irp_" + this.nbRequest ).css("backgroundColor", "#FFFFFF");
            $( "#irp_" + this.nbRequest ).removeAttr('disabled');
        }


        //var indice = context.nbRequest;

    },


    locationChoice: function(ind)
    {
        var option = ind.data[0].toString();

        if ("1" == option)
        {
            $( '#ilocality_' + this.nbRequest).val("");
            $( '#ialtitude_' + this.nbRequest).val("");
            $( '#ilatitude_' + this.nbRequest).val("");
            $( '#ilongitude_' + this.nbRequest).val("");
        }
        else
        {
            $( '#select_iobservatory_' + this.nbRequest).val("");
        }
    },



    checkDate: function()
    {
        var testOk1 = isDate( $( "#iobservation_cpydate_" + this.nbRequest ).val() ) || isEmpty( $( "#iobservation_cpydate_" + this.nbRequest ).val()) ;
        if( !testOk1 )
        {
            alert( tapasTexts["text.errcpydate"] );
            return false;
        }
        return true;
    },



    emptyCpyDate: function()
    {
        if ( this.dateTemp != $( "#iobservation_cpydate_" + this.nbRequest ).val("") ) {
            $( "#iobservation_cpydate_" + this.nbRequest ).val("");
        }
        return true;
    },


    tempDate: function()
    {
        this.dateTemp = "1234";
        return true;
    },

    /*this.createTrList( tapasTexts["label.format"], "iformat_" + this.nbRequest, this.nbRequest, tabPreference, 'format' );
     this.createTrList( tapasTexts["label.era"], "irextinction_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
     this.createTrList( tapasTexts["label.eh2o"], "ih2oe_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
     this.createTrList( tapasTexts["label.eo3"], "io3e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
     this.createTrList( tapasTexts["label.eo2"], "io2e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );
     this.createTrList( tapasTexts["label.eco2"], "ico2e_" + this.nbRequest, this.nbRequest, tabPreference, 'yesno' );

     this.createTrList( tapasTexts["label.observatory"], "iobservatory_" + this.nbRequest, this.nbRequest, tabObservation, 'observatories' );
     this.createCalendar( tabObservation, tapasTexts["label.datemesure"], "iobservation_date_" + this.nbRequest, false, true );

     //unite
     this.createTrList( tapasTexts["label.spectralUnit"], "ispectral_choice_" + this.nbRequest, this.nbRequest, tabObservation, 'spectralUnit' );
     this.createTr2Input( tapasTexts["label.spectralRange"], tapasTexts["label.to"], "iminspectral_ranger_" + this.nbRequest, "imaxspectral_ranger_" + this.nbRequest, tabObservation, "[350,2500] nm" );

     //fonction instrumentale
     this.createTrList( tapasTexts["label.ifunction"], "ifunction_" + this.nbRequest, this.nbRequest, tabObservation, "ilsf" );
     //reference climato
     //this.createTrList( tapasTexts["label.climato"], "icr", tabAtmosphere, "climatoReference" );
     this.createTrList( tapasTexts["label.climato"], "icr_" + this.nbRequest, this.nbRequest, tabObservation, "climatoReference" );


     this.createTr( tapasTexts["label.ira"], "ira_" + this.nbRequest,tabObservation,"hh:mm:ss (J2000)","keypress","ra","2" );
     //this.createTime( tabObservation, tapasTexts["label.ira"], "ira_" + this.nbRequest, false, true,"hh:mm:ss (J2000)" );
     this.createTr( tapasTexts["label.ide"], "ide_" + this.nbRequest, tabObservation, "deg:':''","keypress","de","2" );

     this.createTrTxt( "or", tabObservation );
     this.createTr( tapasTexts["label.iza"], "iza_" + this.nbRequest, tabObservation, "[0,90] &deg;","keypress","za","2" );

     this.createTr( tapasTexts["label.resolution"], "irp_" + this.nbRequest, tabObservation, "", "", "","" );
     this.createTr( tapasTexts["label.ratio"], "isr_" + this.nbRequest, tabObservation, "", "","","" );
     */


    initRequestFields: function()
    {
        if( this.nbRequest > 1 && this.nbRequest <= 9 )
        {
            var indice = this.nbRequest;
            var indice0 = indice - 1;

            //this.selectObservatoriesList[indice].select( this.selectObservatoriesList[indice - 1].getValue(), false );
            $( "#iobservation_date_" + indice ).val( $( "#iobservation_date_" + indice0 ).val() );
            $( "#iobservation_cpydate_" + indice ).val( $( "#iobservation_cpydate_" + indice0 ).val() );
            this.selectSpectralUnitsList[indice].select( this.selectSpectralUnitsList[indice - 1].getValue(), false );

            this.selectInstrumentalFunctionsList[indice].select( this.selectInstrumentalFunctionsList[indice - 1].getValue(), false );
            this.selectClimatoReferencesList[indice].select( this.selectClimatoReferencesList[indice - 1].getValue(), false );

            this.selectFileFormatsList[indice].select( this.selectFileFormatsList[indice - 1].getValue(), false );
            this.select_irextinctionList[indice].select( this.select_irextinctionList[indice - 1].getValue(), false );
            this.select_ih2oeList[indice].select( this.select_ih2oeList[indice - 1].getValue(), false );
            this.select_io3eList[indice].select( this.select_io3eList[indice - 1].getValue(), false );
            this.select_io2eList[indice].select( this.select_io2eList[indice - 1].getValue(), false );
            this.select_ico2eList[indice].select( this.select_ico2eList[indice - 1].getValue(), false );
            this.select_ich4eList[indice].select( this.select_ich4eList[indice - 1].getValue(), false );
            this.select_in2oeList[indice].select( this.select_in2oeList[indice - 1].getValue(), false );
            this.select_iOneTransmissionList[indice].select( this.select_iOneTransmissionList[indice - 1].getValue(), false );
            this.select_ibervCList[indice].select( this.select_ibervCList[indice - 1].getValue(), false );

            $( "#iminspectral_ranger_" + indice ).val( $( "#iminspectral_ranger_" + indice0 ).val() );
            $( "#imaxspectral_ranger_" + indice ).val( $( "#imaxspectral_ranger_" + indice0 ).val() );

            $( "#irp_" + indice ).val( $( "#irp_" + indice0 ).val() );
            $( "#isr_" + indice ).val( $( "#isr_" + indice0 ).val() );
            $( "#ira_" + indice ).val( $( "#ira_" + indice0 ).val() );
            $( "#ide_" + indice ).val( $( "#ide_" + indice0 ).val() );
            $( "#iza_" + indice ).val( $( "#iza_" + indice0 ).val() );


            //      $( "#iobservatory_date_" + indice ).val( $( "#iobservatory_date_" + indice0 ).val() );
            //        $( "#iobservatory_date_" + indice ).val( this.calendarConverter.format( currentDate ) );

            //$( "#iobservatory_date_" + indice ).val( this.calendarConverter.format( this.calendarConverter.parse( $( "#iobservation_date_" + indice0 ).val() ).getTime() ) );
            //      this.selectSpectralUnitsList[z] = this.selectSpectralUnitsList[i];
            /*this.selectSpectralUnitsList[i] = null;
             $( "#iminspectral_ranger_" + i ).attr( {id:"iminspectral_ranger_" + z} );
             $( "#imaxspectral_ranger_" + i ).attr( {id:"imaxspectral_ranger_" + z} );*/

            //$( "#irp_"+indice ).val($( "#irp_"+(indice-1)).val() );

        }
    }

} );

</script>
