<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ page import="com.ether.user.UserRole" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="tiles" uri="/WEB-INF/tlds/struts-tiles.tld" %>
<%@ taglib prefix="ether" tagdir="/WEB-INF/tags" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
    <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">

    <title><tiles:getAsString name="title"/></title>
    <link rel="shortcut icon" href="">

    <ether:htmlCss cssFile="button"/>
    <ether:htmlCss cssFile="complexButton"/>
    <ether:htmlCss cssFile="TwitterLogin/front"/>
    <ether:htmlCss cssFile="mainEther"/>
    <ether:htmlCss cssFile="tapas"/>
    <ether:htmlCss cssFile="backoffice"/>

    <ether:htmlJs jsFile="library/jquery-1.4.2.min"/>
    <ether:htmlJs jsFile="library/jquery.class"/>
    <ether:htmlJs jsFile="library/jquery.protify-0.3"/>
    <ether:htmlJs jsFile="classesForJQuery/etherHelper"/>
    <ether:htmlJs jsFile="classesForJQuery/Button"/>
    <ether:htmlJs jsFile="classesForJQuery/ComplexButton"/>
    <ether:htmlJs jsFile="classesForJQuery/LoginButton"/>
    <ether:htmlJs jsFile="TwitterLogin/javascripts/jquery.tipsy"/>

    <ether:htmlJsp jspFile="templateBackoffice_script"/>

    <tiles:insert attribute="insertCss"/>
    <tiles:insert attribute="insertJsOrJsp"/>
</HEAD>

<BODY>

<%-- ************************************************************************************************************** --%>
<%-- *************************************************** LOGO ETHER *********************************************** --%>
<%-- ************************************************************************************************************** --%>
<div id="linkLogoEther" class="containerLinkLogoEther"></div>

<div id="logoEther" class="containerLogoEther">
    <a href="http://ether.ipsl.jussieu.fr" target="help"><img src="resources/images/logo_Ether.jpg" width="80px" height="80px"/></a>
</div>


<%-- ************************************************************************************************************** --%>
<%-- **************************************************** WRAPPER ************************************************* --%>
<%-- ************************************************************************************************************** --%>
<div class="pageWrapper">

    <%-- ****************** TITLE & TOOLS ****************** --%>
    <div id="title_tools" class="containerTapas">
        <div id="title"></div>

        <div id="tools" align="right">
            <div id="loginModule" align="right"></div>
            <div id="menuBO" class="containerMenu"></div>
        </div>

    </div>

    <%-- ****************** LOGO ****************** --%>
    <div id="logo" class="containerLogo">
       <a href="#"><img src="resources/images/logo_tapas.gif" height="60px" width="60px"></a>
    </div>

    <%-- ****************** MENU ****************** --%>
    <!--<div id="menuBO" class="containerMenu"></div>-->

    <%-- ****************** TITLE CONTENT ****************** --%>
    <div id="titleContent" class="containerTitleContent"><tiles:insert attribute="bodytitle"/>
        <div id="titleContentBorder" class="containerTitleContentBorder"></div>
    </div>

    <%-- ****************** CONTENT ****************** --%>
    <div id="containerCenter" class="containerTapas containerCenter">
        <tiles:insert attribute="body"/>
    </div>

    <%-- ****************** BOTTOM ****************** --%>
    <div id="containerBottom" class="containerTapas containerBottom" align="right">
        &copy; 2013 <a href="http://ether.ipsl.jussieu.fr" target="help">ETHER&nbsp;</a>/ CNRS
    </div>

</div>

<script type="text/javascript">
    var templateTexts = $A( "" );
    templateTexts["app.home"] = '<spring:message code="label.home"/>';
    templateTexts["bo.fulltitle"] = '<spring:message code="bo.fulltitle"/>';
    templateTexts["bo.user"] = '<spring:message code="bo.user"/>';
    templateTexts["bo.site"] = '<spring:message code="bo.site"/>';

    // Needed texts if you use the library LoginButton.js
    var loginTexts = $A( "" );
    loginTexts["app.connexion"] = '<spring:message code="app.connexion"/>';
    loginTexts["login"] = '<spring:message code="login"/>';
    loginTexts["login.password"] = '<spring:message code="login.password"/>';
    loginTexts["login.sign"] = '<spring:message code="login.sign"/>';
    loginTexts["login.pwdForget"] = '<spring:message code="login.pwdForget"/>';
    loginTexts["login.loginForget.help"] = '<spring:message code="login.loginForget.help"/>';
    loginTexts["login.loginForget"] = '<spring:message code="login.loginForget"/>';
    loginTexts["login.error.notFound"] = "<spring:message code='login.error.notFound'/>";
    loginTexts["login.error.wrongPassword"] = "<spring:message code='login.error.wrongPassword'/>";
    loginTexts["login.error.failed"] = "<spring:message code='login.error.failed'/>";
    loginTexts["login.error.notAccepted"] = "<spring:message code='login.error.notAccepted'/>";

    loginTexts["<%=UserRole.ADMINISTRATOR%>"] = '<spring:message code="label.role.administrator"/>';
    loginTexts["<%=UserRole.USER%>"] = '<spring:message code="label.role.user"/>';

    var interfaceTemplate = new InterfaceTemplate();
</script>

<div style="visibility:hidden"><a href="http://apycom.com/">Apycom jQuery Menus</a></div>

</BODY>
</HTML>
