<%@ page import="com.ether.user.UserRole" %>
<%@ page import="com.ether.WebException" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="tiles" uri="/WEB-INF/tlds/struts-tiles.tld" %>
<%@ taglib prefix="ether" tagdir="/WEB-INF/tags" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
    <META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">

    <title><tiles:getAsString name="title"/></title>
    <link rel="shortcut icon" type="image/x-icon" href="resources/images/logo_tapas.gif"/>

    <ether:htmlCss cssFile="apycom.com-4-blue-violet/menu"/>
    <ether:htmlCss cssFile="jquery-ui-1.8.16.custom/jquery-ui-1.8.16.custom"/>
    <ether:htmlCss cssFile="button"/>
    <ether:htmlCss cssFile="complexButton"/>
    <ether:htmlCss cssFile="TwitterLogin/front"/>
    <ether:htmlCss cssFile="jquery-ui-1.8.16.custom/jquery-ui-1.8.16.custom"/>
    <ether:htmlCss cssFile="mainEther"/>
    <ether:htmlCss cssFile="tapas"/>

    <ether:htmlJs jsFile="library/jquery-1.4.2.min"/>
    <ether:htmlJs jsFile="library/jquery.class"/>
    <ether:htmlJs jsFile="library/jquery.protify-0.3"/>
    <ether:htmlJs jsFile="classesForJQuery/etherHelper"/>
    <ether:htmlJs jsFile="classesForJQuery/Button"/>
    <ether:htmlJs jsFile="classesForJQuery/ComplexButton"/>
    <ether:htmlJs jsFile="classesForJQuery/LoginButton"/>
    <ether:htmlJs jsFile="TwitterLogin/javascripts/jquery.tipsy"/>
    <ether:htmlJs jsFile="library/jquery-ui-1.8.16.custom/js/jquery-ui-1.8.16.custom.min"/>
    <ether:htmlJs jsFile="apycom.com-8-orange-red/menu"/>
    <jsp:include page="templateEther_script.jsp"/>

    <tiles:insert attribute="insertCss"/>
    <tiles:insert attribute="insertJsOrJsp"/>


</HEAD>



<BODY>

<%-- ************************************************************************************************************** --%>
<%-- **************************************************** WRAPPER ************************************************* --%>
<%-- ************************************************************************************************************** --%>
<div class="pageWrapper">

    <%-- ****************** TITLE & TOOLS ****************** --%>
    <div id="title_tools" class="containerTapas">
        <div id="title" class="containerTitle"> <spring:message code="app.fulltitle"/></div>
        <div id="title" class="containerTitle2"><a href="http://www.pole-ether.fr" target="_blank"><img src="resources/images/logo_ether.jpg" height="40px" width="40px"></a></div>

        <div id="tools" align="right">
            <div id="loginModule" align="right"></div>
        </div>

    </div>

    <%-- ****************** LOGO ****************** --%>
    <div id="logo" class="containerLogo">
        <a href="#"><img src="resources/images/logo_tapas.gif" height="82px" width="86px"></a>
    </div>

    <%-- ****************** NAV ****************** --%>
    <!--<div id="nav" class="containerNav"><tiles:insert attribute="nav"/></div>-->

    <%-- ****************** MENU ****************** --%>
    <div id="menu" class="containerMenu">

        <ul class="menu">
            <!--<li><a href="http://ether.ipsl.jussieu.fr" class="parent" target="_blank"><img width=25 height="25" src="resources/images/logo_ether.jpg"></a></li>-->

            <li><a href="#" onClick="openHome();" class="parent"><span><spring:message code="title.home"/></span></a></li>

            <li id="liamenu"><a href="data?methodName=viewForm" id="amenu" class="parent"><span><spring:message code="title.form"/></span></a></li>

            <li><a href="#" onclick="openLegals();"><span><spring:message code="title.legals"/></span></a></li>

        </ul>
    </div>

    <%-- ****************** TITLE CONTENT ****************** --%>

    <div id="titleContent" class="containerTitleContent"><tiles:insert attribute="bodytitle"/>

    </div>

    <%-- ****************** CONTENT ****************** --%>
    <div id="containerCenter" class="containerTapas containerCenter">
        <tiles:insert attribute="body"/>
    </div>

    <%-- ****************** BOTTOM ****************** --%>
    <div id="containerBottom" class="containerTapas containerBottom" align="right">
        &copy; 2012-2014 <a href="http://ether.ipsl.jussieu.fr" target="help">ETHER&nbsp;</a>/ CNRS
    </div>
</div>

<div style="visibility:hidden"><a href="http://apycom.com/">Apycom jQuery Menus</a></div>


<script type="text/javascript">
    var templateTexts = $A( "" );
    templateTexts["<%=WebException.WebCode.USER_ALREADY_EXISTS%>"] = "<spring:message code="USER_ALREADY_EXISTS"/>";

    // Needed texts if you use the library LoginButton.js
    var loginTexts = $A( "" );
    loginTexts["app.connexion"] = '<spring:message code="app.connexion"/>';
    loginTexts["login"] = '<spring:message code="login"/>';
    loginTexts["login.password"] = '<spring:message code="login.password"/>';
    loginTexts["login.sign"] = '<spring:message code="login.sign"/>';
    loginTexts["login.pwdForget"] = '<spring:message code="login.pwdForget"/>';
    loginTexts["login.loginForget"] = '<spring:message code="login.loginForget"/>';
    loginTexts["login.loginForget.help"] = '<spring:message code="login.loginForget.help"/>';
    loginTexts["login.inscription"] = '<spring:message code="login.inscription"/>';
    loginTexts["login.error.notFound"] = "<spring:message code='login.error.notFound'/>";
    loginTexts["login.error.wrongPassword"] = "<spring:message code='login.error.wrongPassword'/>";
    loginTexts["login.error.failed"] = "<spring:message code='login.error.failed'/>";
    loginTexts["login.error.notAccepted"] = "<spring:message code='login.error.notAccepted'/>";
    loginTexts["login.text"] = "<spring:message code='login.text'/>";

    loginTexts["<%=UserRole.ADMINISTRATOR%>"] = '<spring:message code="label.role.administrator"/>';
    loginTexts["<%=UserRole.USER%>"] = '<spring:message code="label.role.user"/>';

    var interfaceTemplate = new InterfaceTemplate();

    function openLegals() {
        location.href="project?methodName=mentionsl_"+interfaceTemplate.language;
    }

    function openHome() {
            location.href="project?methodName=home_"+interfaceTemplate.language;
    }

</script>

</BODY>
</HTML>
